<%@ Import Namespace="System.Security.Principal" %>

<html>
<head>
<link rel="stylesheet" href="demos.css">
<script language="VB" runat="server">

     ' Simple wrapper around User.IsInRole (IPrincipal.IsInRole) that does the check
     ' then sets the text on a label
     sub CheckRole(roleName As String, lbl As System.Web.UI.WebControls.Label)
        if User.IsInRole(roleName) then
           lbl.Text = "yes"
        else
           lbl.Text = "no"
        end if

     end sub


     Sub Page_Load(src As Object, e As EventArgs)
		' get Authenticated User
        UserName.Text = User.Identity.Name
        
        ' get thread security context
        ThreadUser.Text = WindowsIdentity.GetCurrent().Name
        
        ' check roles
        ' note that all roles require full qualification and
        ' "BUILTIN" roles require the appropriate authority
        ' WindowsPrincipal.IsInRole has an overload that supports locale
        ' friendly versions of the standard Windows groups
        CheckRole("BUILTIN\Users", UsersRole)
        CheckRole("BUILTIN\Power Users", PowerUsersRole)
        CheckRole("BUILTIN\Administrators", AdminRole)
        CheckRole("BUILTIN\Guests", GuestRole)
        CheckRole("NT AUTHORITY\AUTHENTICATED USERS", AuthUsersRole)
        CheckRole("Everyone", EveryoneRole)
        CheckRole("NT AUTHORITY\INTERACTIV", InteractiveRole)
     End Sub


</script>
</head>
<body>
		<h3 class="HomeHeader">
			<font face="Verdana">Windows Authorization</font>
		</h3>
		<form runat="server">
			<table>
				<tr>
					<td class="SubContentHeader">
						Identity
					</td>
					<td class="ContentHeader">
						<asp:label id="UserName" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Thread Identity
					</td>
					<td class="ContentHeader">
						<asp:label id="ThreadUser" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Everyone
					</td>
					<td class="ContentHeader">
						<asp:label id="EveryoneRole" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Guest
					</td>
					<td class="ContentHeader">
						<asp:label id="GuestRole" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Authenticated Users
					</td>
					<td class="ContentHeader">
						<asp:label id="AuthUsersRole" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Users
					</td>
					<td class="ContentHeader">
						<asp:label id="UsersRole" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Power Users
					</td>
					<td class="ContentHeader">
						<asp:label id="PowerUsersRole" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Interactive
					</td>
					<td class="ContentHeader">
						<asp:label id="InteractiveRole" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Local
					</td>
					<td class="ContentHeader">
						<asp:label id="LocalRole" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Custom Role 1
					</td>
					<td class="ContentHeader">
						<asp:label id="CustRole1" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Custom Role 2
					</td>
					<td class="ContentHeader">
						<asp:label id="CustRole2" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Custom Guest
					</td>
					<td class="ContentHeader">
						<asp:label id="CustGuest" runat="server" />
					</td>
				</tr>
				<tr>
					<td class="SubContentHeader">
						Admin
					</td>
					<td class="ContentHeader">
						<asp:label id="AdminRole" runat="server" />
					</td>
				</tr>
			</table>
		</form>
	</body>
</html>
