Imports System.Data
Imports System.Data.SqlClient
Imports System.Diagnostics
Imports System.Security.Principal
Imports System.Text

Public Class injection
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents txtUser As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
    Protected WithEvents Button1 As System.Web.UI.WebControls.Button
    Protected WithEvents Msg As System.Web.UI.WebControls.Label
    Protected WithEvents Diag As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
    End Sub

    ' *Bad example* of data validation for pedagogical purposes
    ' Please do not copy this code and use it
    ' input data is intentionally not validated
    ' SQL query is constructed on the fly, leading to SQL injection
    ' input data is echoed back without validation
    Public Sub OnLogon(ByVal Src As Object, ByVal E As EventArgs)
        Dim userName As String = txtUser.Text
        Dim passwd As String = txtPassword.Text

        ' bad: SQL connection string is hardcoded in program source
        Dim conn As New SqlConnection("server=(local);database=formsdb;Trusted_Connection=True")

        ' bad practice: constructing SQL on the fly,
        ' subject to SQL injection
        Dim query As String = String.Format("SELECT username, password FROM userinfo WHERE username='{0}' AND password='{1}'", userName, passwd)
        Dim cmd As New SqlCommand(query, conn)

        conn.Open()
        Dim rdr As SqlDataReader = cmd.ExecuteReader()
        Try
            If rdr.HasRows() Then
                ' bad: CSS attack from echo'ing
                ' unencoded input
                Msg.Text = "Welcome, " & userName
            Else
                ' bad: CSS attack from echo'ing
                ' unencoded input
                ' no failure auditing
                Msg.Text = String.Format("Invalid Logon for {0}, please try again", Server.HtmlEncode(userName))
            End If

        Finally
            rdr.Close()
            conn.Close()

            ' output query for diagnostic purposes (clearly not a great security practice either ;-)
            Diag.Text = Server.HtmlEncode(query)

        End Try

    End Sub

    Public Sub OnLogonBetter(ByVal Src As Object, ByVal E As EventArgs)
        Dim userName As String = txtUser.Text
        Dim passwd As String = txtPassword.Text

        ' step one, validate userName and password
        ' this could also be done with server controls, which is recommended
        ' allow only letters and digits and underscore
        ' Dim valid = new Regex("^[a-zA-Z0-9]+$")

        ' still bad: SQL connection string is hardcoded in program source
        ' better: using integrated auth and least privilege on table
        Dim conn As New SqlConnection("server=(local);database=formsdb;Trusted_Connection=True")

        ' better practice: using parameterized queries or stored procedures
        Dim cmd As New SqlCommand("select username, password from userinfo where username=@username and password=@passwd", conn)

        Dim param As SqlParameter = cmd.Parameters.Add("@username", SqlDbType.NVarChar, 30)
        param.Value = userName

        param = cmd.Parameters.Add("@passwd", SqlDbType.NVarChar, 30)
        param.Value = passwd

        conn.Open()
        Dim rdr As SqlDataReader = cmd.ExecuteReader()
        Dim ok As Boolean = False

        Try
            If rdr.HasRows() Then
                If rdr.Read Then
                    If rdr.GetString(0) = userName And rdr.GetString(1) = passwd Then
                        Msg.Text = "Welcome, " & Server.HtmlEncode(userName)
                        ok = True
                    End If
                End If
            End If
            If Not ok Then
                ' think hard about whether or not to log the password (don't unless there's a good reason for it)
                ' the SQL query above could be altered to just return the username
                ' with an explicit password comparison to provide more info about what went wrong
                LogFailure(userName)
                Msg.Text = String.Format("Invalid Logon for {0}, please try again", Server.HtmlEncode(userName))
            End If

        Finally
            rdr.Close()
            conn.Close()
        End Try

    End Sub


    Public Sub LogFailure(ByVal userName As String)
        Dim EventLogSource As String = "TechEdDemos"
        ' if we're impersonating e.g. the IUSR account, we won't be able to write to
        ' the event log on WS03 until we change the DACL
        ' Both approaches have tradeoffs but we'll revert here
        Dim wic As WindowsImpersonationContext = WindowsIdentity.Impersonate(IntPtr.Zero)
        Try
            If EventLog.SourceExists(EventLogSource) Then
                Dim sb As New StringBuilder
                Dim evLog = New EventLog("Application")
                evLog.Source = EventLogSource

                sb.Append("TechDemoApp: Audit Failure")
                sb.Append(ControlChars.CrLf)
                sb.AppendFormat("UserName: {0}{1}", Server.HtmlEncode(userName), ControlChars.CrLf)
                sb.AppendFormat("Remote IP: {0}{1}", Request.ServerVariables("REMOTE_ADDR"), ControlChars.CrLf)
                evLog.WriteEntry(sb.ToString(), EventLogEntryType.FailureAudit)
            End If
        Finally
            If Not IsNothing(wic) Then
                wic.Undo()
            End If
        End Try
    End Sub

End Class
