using System;
using System.Security.Cryptography;
using System.Text;
using System.IO;

public class SaltHash {
    public static void Main(string[] args) {

	if( args.Length != 1 ) {
	    Console.WriteLine("Usage salthash passwd");
	    return;
	}

	const int saltSize = 16;
	
	// step 1: create some entropy for use as the salt
	RandomNumberGenerator rng = RandomNumberGenerator.Create();
	byte[] salt = new byte[ saltSize ];
	rng.GetBytes(salt);


	// step 2: turn the password into bytes
	byte[] secret = Encoding.Unicode.GetBytes(args[0]);


	// step 3: create the hash
	HashAlgorithm hashAlg = SHA1.Create();
	using(CryptoStream cs = new CryptoStream(Stream.Null, hashAlg, CryptoStreamMode.Write)) {
	    cs.Write(secret, 0, secret.Length);
	    cs.Write(salt, 0, salt.Length);
	    cs.FlushFinalBlock();
	}

	// step 4: spit out the hash + the salt in Base64 
	// in this format: Base64(hash),Base64(salt)
	StringBuilder hashOutput = new StringBuilder( 256 );
	hashOutput.Append(Convert.ToBase64String(hashAlg.Hash));
	hashOutput.Append(",");
	hashOutput.Append(Convert.ToBase64String(salt));

	// step 5: spit it out
	Console.WriteLine(hashOutput.ToString());

    }
}