using System;
using System.Security.Cryptography;
using System.Text;
using System.IO;

public class VerifyHash {

    
    public static void Main(string[] args) {

	if( args.Length != 2 ) {
	    Console.WriteLine("Usage verifyhash passwd hashBlob");
	    return;
	}

	string passwd = args[0];
	string hashBlob = args[1];


	// step 1: retrieve the salt
	int comma = hashBlob.IndexOf(",");

	if( -1 == comma ) {
	    Console.WriteLine("Can't find delimiter for salt...exiting without match");
	    return;
	}

	string hashPortion = hashBlob.Substring(0, comma);
	string saltPortion = hashBlob.Substring(comma+1); // skip the comma itself
	byte[] salt = Convert.FromBase64String(saltPortion);


	// step 2: create the hash based on the supplied password
	byte[] secret = Encoding.Unicode.GetBytes(args[0]);
	HashAlgorithm hashAlg = SHA1.Create();
	using(CryptoStream cs = new CryptoStream(Stream.Null, hashAlg, CryptoStreamMode.Write)) {
	    cs.Write(secret, 0, secret.Length);
	    cs.Write(salt, 0, salt.Length);
	    cs.FlushFinalBlock();
	}


	// step 3: compare the hash we created to the supplied blob
	byte[] hashDigest = hashAlg.Hash;
	bool match = false;
	bool foundMismatch = false;
	byte[] blobBytes = Convert.FromBase64String(hashPortion);

	if( hashDigest.Length == blobBytes.Length ) {
	    for( int i = 0; i < hashDigest.Length; i++ ) {
		if( hashDigest[i] != blobBytes[i] ) {
		    foundMismatch = true;
		    break;
		}
	    }

	    match = !foundMismatch;
	}

	if( match ) {
	    Console.WriteLine("Password verified");
	}
	else {
	    Console.WriteLine("Password failed verification");
	}

    }
}
