Imports System
Imports System.Runtime.InteropServices
Imports System.Text

' Note that this class does not suppress stackwalks,
' so the callers are required to hold SecurityPermissionFlag.UnmanagedCode
Friend NotInheritable Class NativeMethods
    ' nested classes	      
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
    Friend Class CRYPTPROTECT_PROMPTSTRUCT
        Public cbSize As Integer = Marshal.SizeOf(GetType(CRYPTPROTECT_PROMPTSTRUCT))
        Public dwPromptFlags As Integer = 0
        Public hwndApp As IntPtr = IntPtr.Zero
        Public szPrompt As String = Nothing
    End Class 'CRYPTPROTECT_PROMPTSTRUCT

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
    Friend Structure DATA_BLOB
        Public cbData As Integer
        Public pbData As IntPtr
    End Structure 'DATA_BLOB


    ' fields
    ' some useful flags for the DPAPI methods
    Friend Const Audit As Integer = &H10
    Friend Const CredSync As Integer = &H8
    ' the LocalMachine flag enables data to be encrypted for the current
    ' computer.  Omitting this flag is often what one wants for client
    ' applications.  Server applications and services often need to use
    ' the LocalMachine flag to avoid issues with specific user profiles
    Friend Const LocalMachine As Integer = &H4
    Friend Const NoRecovery As Integer = &H20
    Friend Const PromptOnProtect As Integer = &H2
    Friend Const PromptOnUnprotect As Integer = &H1
    Friend Const PromptStrong As Integer = &H8
    Friend Const UIForbidden As Integer = &H1
    Friend Const VerifyProtection As Integer = &H40


    ' methods      
    ' p/invoke decls
    Declare Auto Function CryptProtectData Lib "crypt32.dll" ( _
        ByRef dataIn As DATA_BLOB, ByVal szDataDescr As String, _
        ByRef optionalEntropy As DATA_BLOB, ByVal pvReserved As IntPtr, _
        ByVal pPromptStruct As IntPtr, ByVal dwFlags As Integer, _
        ByRef pDataOut As DATA_BLOB) As Boolean


    Declare Auto Function CryptUnprotectData Lib "crypt32.dll" ( _
       ByRef dataIn As DATA_BLOB, ByVal ppszDataDescr As StringBuilder, _
       ByRef optionalEntropy As DATA_BLOB, ByVal pvReserved As IntPtr, _
       ByVal pPromptStruct As IntPtr, ByVal dwFlags As Integer, _
       ByRef pDataOut As DATA_BLOB) As Boolean


    ' to free data returned from CryptProtectData
    Declare Auto Function LocalFree Lib "kernel32" ( _
       ByVal hMem As IntPtr) As IntPtr

End Class 'NativeMethods
