Imports Microsoft.Win32
Imports System.Text

Public Class WebForm1
    Inherits System.Web.UI.Page
    Protected WithEvents CipherSecretLabel As System.Web.UI.WebControls.Label
    Protected WithEvents HyperLink1 As System.Web.UI.WebControls.HyperLink
    Protected WithEvents ClearTextLabel As System.Web.UI.WebControls.Label

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' consult config for saltname (required by DPAPI) and regkey
        ' reg key is relative to HKLM
        Dim salt As String = ConfigurationSettings.AppSettings("secretName")
        Dim regName As String = ConfigurationSettings.AppSettings("secretReg")
        Dim regValueName As String = ConfigurationSettings.AppSettings("secretRegValue")
        Dim cipherSecret As String = Nothing

        ' grab the entropy and convert to Bytes
        Dim entropyStr As String = ConfigurationSettings.AppSettings("entropy")
        Dim entropyBits As Byte() = Encoding.Unicode.GetBytes(entropyStr)


        ' open Key for read (careful to only use read, since we can't write)
        Dim regKey As RegistryKey = Registry.LocalMachine.OpenSubKey(regName, False)
        If Not IsNothing(regKey) Then
            Dim cipherData As Object = regKey.GetValue(regValueName)
            If Not IsNothing(cipherData) Then
                cipherSecret = CType(cipherData, String)
            End If
        End If

        If IsNothing(cipherSecret) Then
            CipherSecretLabel.Text = "No Secret Stored"
        Else
            ' If we got a key, decrypt it and display it
            CipherSecretLabel.Text = cipherSecret
            Dim clearText As String = DataProtection.UnprotectData(cipherSecret, entropyBits)
            ClearTextLabel.Text = clearText
        End If

        Array.Clear(entropyBits, 0, entropyBits.Length)
    End Sub

End Class
